/*
 * Author: Jerome Kerdreux, Copyright: GPL
 * 
 *
 * Chip type           : ATTiny2313
 * Clock frequency     : Internal clock 1 Mhz (factory default)
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h> 
#include "test_avr.h"
#include "avr_compat.h"
#include "io_macro.h"




// IO declaration 
#define CLOCK    D,0
#define STROBE   D,1
#define BLANK    A,1
#define DATA     A,0



//========================================================================================
// small delay to wait 
//========================================================================================
void small_delay(void)
{
  unsigned char inner;
  unsigned char top;
  inner = 70;  // tweak this, depending on the cpu clock
  top = 2;
  while (top)
    {
      while (inner)
	{
	  inner--;
	}
      top--;
    }
}



void init_io(void)
{
  drive(CLOCK);
  drive(STROBE);
  drive(BLANK);
  drive(DATA);
}



void send_data(unsigned char d)
{
  clr_output(CLOCK);
  if (d ==0) clr_output(DATA);
  if (d ==1) set_output(DATA);
  small_delay();
  set_output(CLOCK);
  small_delay();
}


void main(void)
{
  init_io();
  small_delay();
  set_output(BLANK);

  clr_output(STROBE); 

  while (1)
    {

      //send_data(0);
      send_data(1);

      // enable Latch 
      set_output(STROBE);
      small_delay();
      clr_output(STROBE);
      small_delay();


      //enable blank
      clr_output(BLANK);
      small_delay();
      small_delay();
      small_delay();
      small_delay();
      small_delay();
      set_output(BLANK);
      small_delay();
      


    }
   
}
